Const gsDots = 1
Const gsLines = 2
Const Millimetres = 1
Const Inches = 2
Type QGrid extends QCanvas
     Public :
     Units     as integer
     StepX     as double
     StepY     as double
     Scale     as double
     GridStyle as integer
     GridColor as integer
     
     Function ToPixel(Value as double) as double
     If QGrid.Units = 1 then Result = Value / 25.4 * 100 ' MM
     If QGrid.Units = 2 then Result = Value * 100        ' Inch
     End Function
     
     Event OnPaint
     Dim x as double
     Dim y as double
          With QGrid
          If .Scale < 1 then Exit Sub
               If .GridStyle = 1 then
                   For y = 0 to .Height step .ToPixel(.StepY) * .Scale
                      For x = 0 to .Width step .ToPixel(.StepX) * .Scale
                          .Pixel(x,y) = .GridColor
                      Next x
                   Next y
               End If
               If .GridStyle = 2 then
                  For y = 0 to .Height step .ToPixel(.StepY) * .Scale
                      For x = 0 to .Width step .ToPixel(.StepX) * .Scale
                          .Line(x,0,x,.Height,.GridColor)
                      Next x
                          .Line(0,y,.Width,y,.GridColor)
                  Next y
               End If
               If .GridStyle = 3 then
                  For y = 0 to .Height step .ToPixel(.StepY) * .Scale
                      For x = 0 to .Width step .ToPixel(.StepX) * .Scale
                         .Line(x,y - .ToPixel(.StepY)/4 * .Scale,x,y + .ToPixel(.StepY)/4 * .Scale,.GridColor)
                         .Line(x - .ToPixel(.StepX)/4 * .Scale,y,x + .ToPixel(.StepX)/4 * .Scale ,y,.GridColor)
                      Next x
                  Next y
               End If
          End With
     End Event
     
     Sub Invalidate
     QGrid.Repaint
     End Sub
     
     Constructor
     Units      = 2
     Scale     = 1
     StepX     = 2.54
     StepY     = 2.54
     GridStyle = 1
     GridColor = 0
     End Constructor
End Type
